QT -= gui
QT += core webchannel websockets

CONFIG += c++11 console
CONFIG -= app_bundle

# You can make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

SOURCES += \
        algorithms/XYZ2ELL.cpp \
        algorithms/blh2xyz.cpp \
        algorithms/colon.cpp \
        algorithms/eml_rand_mt19937ar.cpp \
        algorithms/fun10_distcal.cpp \
        algorithms/fun10_histcounts.cpp \
        algorithms/fun10_multifx.cpp \
        algorithms/fun10_sort.cpp \
        algorithms/fun10_sortIdx.cpp \
        algorithms/fun1_FFTImplementationCallback.cpp \
        algorithms/fun1_false_target_distance.cpp \
        algorithms/fun1_fft.cpp \
        algorithms/fun1_fftshift.cpp \
        algorithms/fun1_ifft.cpp \
        algorithms/fun2.cpp \
        algorithms/fun4_S_jam.cpp \
        algorithms/fun4_S_orignal.cpp \
        algorithms/fun5.cpp \
        algorithms/fun6.cpp \
        algorithms/fun7_DRFMRF.cpp \
        algorithms/fun7_DRFMRF_data.cpp \
        algorithms/fun7_DRFMRF_initialize.cpp \
        algorithms/fun7_FFTImplementationCallback.cpp \
        algorithms/fun7_eml_rand_mt19937ar_stateful.cpp \
        algorithms/fun7_ifft.cpp \
        algorithms/fun7_randn.cpp \
        algorithms/fun8_2_FFTImplementationCallback.cpp \
        algorithms/fun8_2_FMjamming_H.cpp \
        algorithms/fun8_2_FMjamming_H_data.cpp \
        algorithms/fun8_2_eml_rand_mt19937ar_stateful.cpp \
        algorithms/fun8_2_ifft.cpp \
        algorithms/fun8_2_randn.cpp \
        algorithms/fun8_2_std.cpp \
        algorithms/fun8_3_FFTImplementationCallback.cpp \
        algorithms/fun8_3_eml_rand_mt19937ar_stateful.cpp \
        algorithms/fun8_3_ifft.cpp \
        algorithms/fun8_3_jamming_H.cpp \
        algorithms/fun8_3_jamming_H_data.cpp \
        algorithms/fun8_3_randn.cpp \
        algorithms/fun8_AMJamming_H.cpp \
        algorithms/fun8_AMJamming_H_data.cpp \
        algorithms/fun8_FFTImplementationCallback.cpp \
        algorithms/fun8_eml_rand_mt19937ar_stateful.cpp \
        algorithms/fun8_randn.cpp \
        algorithms/fun8_std.cpp \
        algorithms/fun9_pinv.cpp \
        algorithms/fun9_svd.cpp \
        algorithms/fun9_tdoa1.cpp \
        algorithms/fun9_xaxpy.cpp \
        algorithms/fun9_xnrm2.cpp \
        algorithms/fun9_xrotg.cpp \
        algorithms/rt_nonfinite.cpp \
        main.cpp \
        wsserver.cpp

# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target

HEADERS += \
    algorithms/XYZ2ELL.h \
    algorithms/blh2xyz.h \
    algorithms/coder_array.h \
    algorithms/colon.h \
    algorithms/eml_rand_mt19937ar.h \
    algorithms/fun10_distcal.h \
    algorithms/fun10_histcounts.h \
    algorithms/fun10_multifx.h \
    algorithms/fun10_sort.h \
    algorithms/fun10_sortIdx.h \
    algorithms/fun1_FFTImplementationCallback.h \
    algorithms/fun1_false_target_distance.h \
    algorithms/fun1_fft.h \
    algorithms/fun1_fftshift.h \
    algorithms/fun1_ifft.h \
    algorithms/fun2.h \
    algorithms/fun4_S_jam.h \
    algorithms/fun4_S_orignal.h \
    algorithms/fun5.h \
    algorithms/fun6.h \
    algorithms/fun7_DRFMRF.h \
    algorithms/fun7_DRFMRF_data.h \
    algorithms/fun7_DRFMRF_initialize.h \
    algorithms/fun7_FFTImplementationCallback.h \
    algorithms/fun7_eml_rand_mt19937ar_stateful.h \
    algorithms/fun7_ifft.h \
    algorithms/fun7_randn.h \
    algorithms/fun8_2_FFTImplementationCallback.h \
    algorithms/fun8_2_FMjamming_H.h \
    algorithms/fun8_2_FMjamming_H_data.h \
    algorithms/fun8_2_eml_rand_mt19937ar_stateful.h \
    algorithms/fun8_2_ifft.h \
    algorithms/fun8_2_randn.h \
    algorithms/fun8_2_std.h \
    algorithms/fun8_3_FFTImplementationCallback.h \
    algorithms/fun8_3_eml_rand_mt19937ar_stateful.h \
    algorithms/fun8_3_ifft.h \
    algorithms/fun8_3_jamming_H.h \
    algorithms/fun8_3_jamming_H_data.h \
    algorithms/fun8_3_randn.h \
    algorithms/fun8_AMJamming_H.h \
    algorithms/fun8_AMJamming_H_data.h \
    algorithms/fun8_FFTImplementationCallback.h \
    algorithms/fun8_eml_rand_mt19937ar_stateful.h \
    algorithms/fun8_randn.h \
    algorithms/fun8_std.h \
    algorithms/fun9_pinv.h \
    algorithms/fun9_svd.h \
    algorithms/fun9_tdoa1.h \
    algorithms/fun9_xaxpy.h \
    algorithms/fun9_xnrm2.h \
    algorithms/fun9_xrotg.h \
    algorithms/rt_defines.h \
    algorithms/rt_nonfinite.h \
    algorithms/rtwtypes.h \
    algorithms/tmwtypes.h \
    wsserver.h
